/*              Copyright (c) 1995 Daniele Terdina
*/

#include <signal.h>
#include "QLtypes.h"
#include "QL68000.h"

#include "vm.h"

void debug(char*);
void debug2(char*,long);

void    (**table)(void);

#ifdef DEBUG
int trace_rts=0;
#endif

#define INLINE


#ifdef USE_VM
extern int vm_ison;
sigjmp_buf instr_retry_catch;
#define vml static
#else
#define vml static
#endif






#ifdef DEBUG
#define TRR  {trace_rts=20;}
#else 
#define TRR
#endif


vml inline w32     GetEA_m2(short) REGP1;
vml inline w32     GetEA_m5(short) REGP1;
vml inline w32     GetEA_m6(short) REGP1;
vml inline w32     GetEA_m7(short) REGP1;
vml inline w32     GetEA_mBad(short) REGP1;
w32
(*iexl_GetEA[8])(short) REGP1 ={GetEA_mBad,GetEA_mBad,GetEA_m2,GetEA_mBad,GetEA_mBad,
		    GetEA_m5,GetEA_m6,GetEA_m7};
vml w32 (**ll_GetEA)(short) REGP1 =iexl_GetEA;

vml inline w8      GetFromEA_b_m0(void);
vml inline w8      GetFromEA_b_mBad(void);
vml inline w8      GetFromEA_b_m2(void);
vml inline w8      GetFromEA_b_m3(void);
vml inline w8      GetFromEA_b_m4(void);
vml inline w8      GetFromEA_b_m5(void);
vml inline w8      GetFromEA_b_m6(void); 
vml inline w8      GetFromEA_b_m7(void);
w8
(*iexl_GetFromEA_b[8])(void)={GetFromEA_b_m0,GetFromEA_b_mBad,GetFromEA_b_m2,
			 GetFromEA_b_m3,GetFromEA_b_m4,GetFromEA_b_m5,GetFromEA_b_m6,GetFromEA_b_m7};
vml w8 (**ll_GetFromEA_b)(void)=iexl_GetFromEA_b;


vml inline w16     GetFromEA_w_m0(void);
vml inline w16     GetFromEA_w_m1(void);
vml inline w16     GetFromEA_w_m2(void);
vml inline w16     GetFromEA_w_m3(void);
vml inline w16     GetFromEA_w_m4(void);
vml inline w16     GetFromEA_w_m5(void);
vml inline w16     GetFromEA_w_m6(void);
vml inline w16     GetFromEA_w_m7(void);
w16
(*iexl_GetFromEA_w[8])(void)={GetFromEA_w_m0,GetFromEA_w_m1,GetFromEA_w_m2,
			 GetFromEA_w_m3,GetFromEA_w_m4,GetFromEA_w_m5,GetFromEA_w_m6,GetFromEA_w_m7};
vml w16 (**ll_GetFromEA_w)(void)=iexl_GetFromEA_w;

vml inline w32     GetFromEA_l_m0(void);
vml inline w32     GetFromEA_l_m1(void);
vml inline w32     GetFromEA_l_m2(void);
vml inline w32     GetFromEA_l_m3(void);
vml inline w32     GetFromEA_l_m4(void);
vml inline w32     GetFromEA_l_m5(void);
vml inline w32     GetFromEA_l_m6(void);
vml inline w32     GetFromEA_l_m7(void);
w32
(*iexl_GetFromEA_l[8])(void)={GetFromEA_l_m0,GetFromEA_l_m1,GetFromEA_l_m2,
			 GetFromEA_l_m3,GetFromEA_l_m4,GetFromEA_l_m5,GetFromEA_l_m6,GetFromEA_l_m7};
vml w32 (**ll_GetFromEA_l)(void)=iexl_GetFromEA_l;


vml inline void PutToEA_b_m0(short,w8) REGP2;
vml inline void PutToEA_b_mBad(short,w8) REGP2;
vml inline void PutToEA_b_m2(short,w8) REGP2;
vml inline void PutToEA_b_m3(short,w8) REGP2;
vml inline void PutToEA_b_m4(short,w8) REGP2;
vml inline void PutToEA_b_m5(short,w8) REGP2;
vml inline void PutToEA_b_m6(short,w8) REGP2;
vml inline void PutToEA_b_m7(short,w8) REGP2;
void
(*iexl_PutToEA_b[8])(short,w8) REGP2 ={PutToEA_b_m0,PutToEA_b_mBad,PutToEA_b_m2,PutToEA_b_m3,PutToEA_b_m4,PutToEA_b_m5,PutToEA_b_m6,PutToEA_b_m7};

vml void (**ll_PutToEA_b)(short,w8) REGP2 =iexl_PutToEA_b;

vml inline void PutToEA_w_m0(short,w16) REGP2;
vml inline void PutToEA_w_m1(short,w16) REGP2;
vml inline void PutToEA_w_m2(short,w16) REGP2;
vml inline void PutToEA_w_m3(short,w16) REGP2;
vml inline void PutToEA_w_m4(short,w16) REGP2;
vml inline void PutToEA_w_m5(short,w16) REGP2;
vml inline void PutToEA_w_m6(short,w16) REGP2;
vml inline void PutToEA_w_m7(short,w16) REGP2;
void
(*iexl_PutToEA_w[8])(short,w16) REGP2 ={PutToEA_w_m0,PutToEA_w_m1,PutToEA_w_m2,
			    PutToEA_w_m3,PutToEA_w_m4,PutToEA_w_m5,PutToEA_w_m6,PutToEA_w_m7};

vml void (**ll_PutToEA_w)(short,w16) REGP2 =iexl_PutToEA_w;

vml inline void PutToEA_l_m0(short,w32) REGP2;
vml inline void PutToEA_l_m1(short,w32) REGP2;
vml inline void PutToEA_l_m2(short,w32) REGP2;
vml inline void PutToEA_l_m3(short,w32) REGP2;
vml inline void PutToEA_l_m4(short,w32) REGP2;
vml inline void PutToEA_l_m5(short,w32) REGP2;
vml inline void PutToEA_l_m6(short,w32) REGP2;
vml inline void PutToEA_l_m7(short,w32) REGP2;
void
(*iexl_PutToEA_l[8])(short,w32) REGP2 ={PutToEA_l_m0,PutToEA_l_m1,PutToEA_l_m2,
			    PutToEA_l_m3,PutToEA_l_m4,PutToEA_l_m5,PutToEA_l_m6,PutToEA_l_m7};

void (**ll_PutToEA_l)(short,w32) REGP2 =iexl_PutToEA_l;

vml inline Cond CondT(void);
vml inline Cond CondF(void);
vml inline Cond CondHI(void);
vml inline Cond CondLS(void);
vml inline Cond CondCC(void);
vml inline Cond CondCS(void);
vml inline Cond CondNE(void);
vml inline Cond CondEQ(void);
vml inline Cond CondVC(void);
vml inline Cond CondVS(void);
vml inline Cond CondPL(void);
vml inline Cond CondMI(void);
vml inline Cond CondGE(void);
vml inline Cond CondLT(void);
vml inline Cond CondGT(void);
vml inline Cond CondLE(void);
Cond
(*ConditionTrue[16])(void)={CondT,CondF,CondHI,CondLS,CondCC,CondCS,CondNE,
			    CondEQ,CondVC,CondVS,CondPL,CondMI,CondGE,CondLT,CondGT,CondLE};
vml Cond (**ll_ConditionTrue)(void)=ConditionTrue;

w32             reg[16];                        /* registri d0-d7/a0-a7 */
w32             usp,ssp;                        /* user e system stack
						   pointer (aggiornato solo quello non attivo) */

#ifndef GREGS
uw16    *pc;                            /* program counter : Ptr nella */
uw16    code;
int      nInst;
#endif

Cond    trace,supervisor,xflag,negative,zero,overflow,carry;    /*flags */
char    iMask;                          /* SR interrupt mask */
Cond    stopped;                        /* processor status */
volatile char   pendingInterrupt;       /* interrupt requesting service */

w32             *sp;                            /* *sp=reg[15] : stack
						   pointer */
w32             *aReg;                          /* aReg=reg+8 : address
						   registers */


w32             *theROM;                        /* Ptr to ROM in Mac memory */
w32  *ll_theROM;
w32             *ramTop;                        /* Ptr to RAM top in Mac
						   memory */
w32             RTOP;                           /* QL ram top address */
short   exception;                      /* pending exception */
w32             badAddress;                     /* bad address address */
w16             readOrWrite;            /* bad address action */
w32             dummy;                          /* free 4 bytes for who care */
Ptr             dest;                           /* Mac address for
read+write operations */

Cond    isHW;                           /* dest is a HW register ? */
#if !defined(VM_SCR)
Cond    isDisplay;                      /* dest is in display RAM ? */
#endif
w32             lastAddr;                       /* QL address for
						   read+write operations */


volatile Cond   extraFlag;      /* signals exception or trace */


char    dispScreen=0;           /* screen 0 or 1 */
Cond    dispMode=0;                     /* mode 4 or 8 */
Cond    dispActive=true;        /* display is on ? */
Cond    badCodeAddress;

int   nInst2;
extern int script;

volatile w8     intReg=0;
volatile w8     theInt=0;

Cond doTrace;            /* trace after current instruction */


inline void FlushDisplay()
{
  /* printf("update screen: from %d TO %d\n",displayFrom,displayTo); */
  if (!script)
  scrconv(displayFrom,displayTo);
}

#if defined(USE_VM) || defined (VM_SCR)
#define FlushDisplay()
#endif

/*uw32    qlClock=-1798848000l;*/

/* zona del display modificata; 0=nessuna modifica */
w32    displayFrom=0,displayTo=0;

#if 1
inline  w8 IntRead(void)
{    
  register w8 t;

  t=theInt;
  theInt=0;
  return t;
}

inline  w8 ReadRTClock(w32 addr)
{   
  uw32 t;
  GetDateTime(&t);
  /*  t-=qlClock; */
  while(addr++<0x18003l) t>>=8;
  return (w8)t;
}



inline w8 ReadHWByte(w32 addr)
{    
  int res=0;
  
  /*printf("read HWreg %x, ",addr-0x18000);*/
  
  switch(addr) {
  case 0x018000: /* Read from real-time clock */
  case 0x018001:
  case 0x018002:
  case 0x018003:
    return res=ReadRTClock(addr);
  case 0x018020: debug("Read from MDV/RS232 status");
    debug2("PC-2=",(Ptr)pc-(Ptr)theROM-2);
    break;
  case 0x018021: res=IntRead();
  case 0x018022: /*debug("Read from MDV track 1");*/ break;
  case 0x018023: /*debug("Read from MDV track 2");*/ break;
  default:   debug2("Read from HW register ",addr);
             debug2("at (PC-2) ",(Ptr)pc-(Ptr)theROM-2); 
    break;
  }
  /*printf("result %x \n",res);*/
  return res;
}
/* Q-emuLator uses machine code language to replace the following three
heavily used routines */
#endif  /* 1 */

/******************************************************************/


void ProcessInterrupts(void) 
{   
  /* gestione interrupts */
  if( exception==0 && (pendingInterrupt==7 || pendingInterrupt>iMask)
      && !doTrace)
    {    
      if(!supervisor)
	{   
	  usp=(*sp);
	  (*sp)=ssp;
	}
      ExceptionIn(24+pendingInterrupt);
      WriteLong((*sp)-4,(Ptr)pc-(Ptr)theROM); 
      (*sp)-=6;
      WriteWord(*sp,GetSR());
      SetPCX(24+pendingInterrupt);
      iMask=pendingInterrupt;
      pendingInterrupt=0;
      supervisor=true;
      trace=false;
      stopped=false;
      extraFlag=false;
    }
}

INLINE w16 GetSR(void)
{   
  w16 sr;
  sr=(w16)iMask<<8;
  if(trace) sr|=0x8000;
  if(supervisor) sr|=0x2000;
  if(xflag) sr|=16;
  if(negative) sr|=8;
  if(zero) sr|=4;
  if(overflow) sr|=2;
  if(carry) sr|=1;
  return sr;
}

#ifdef XSCREEN
extern int foolpe;
#endif
INLINE void PutSR(w16 sr)
{  
  Cond oldSuper;
  oldSuper=supervisor;
  trace=(sr&0x8000)!=0;
  extraFlag=doTrace || trace || exception!=0;
  if(extraFlag)
    { 
      nInst2=nInst;
      nInst=0;
    }
  supervisor=(sr&0x2000)!=0;
  xflag=(sr&0x0010)!=0;
  negative=(sr&0x0008)!=0;
  zero=(sr&0x0004)!=0;
  overflow=(sr&0x0002)!=0;
  carry=(sr&0x0001)!=0;
  iMask=(char)(sr>>8)&7;
  if(oldSuper!=supervisor)
    { 
      if(supervisor)
	{ 
	  usp=(*sp);
	  (*sp)=ssp;
	}
      else
	{ 
	  ssp=(*sp);
	  (*sp)=usp;
#if 0 /*XSCREEN */
	  if (foolpe)
	    {
	      foolpe=0;
	      XfixCh();
	    }
#endif
	}
    }
  ProcessInterrupts();
}

inline w16 BusErrorCode(w16 dataOrCode)
{    
  if(supervisor) dataOrCode+=4;
  return dataOrCode+readOrWrite+8;
}


INLINE void SetPCX(int i)
{
#ifdef BACKTRACE
  Ptr p=pc;
#endif

  pc=(uw16*)((Ptr)theROM+(RL(&theROM[i])&ADDR_MASK));
  
#ifdef TRACE 
  CheckTrace();
#ifdef BACKTRACE
  AddBackTrace(p,-i);
#endif
#endif
  
  if(((char)pc&1)!=0)
    { 
      exception=3;
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
      readOrWrite=16;
      badAddress=(Ptr)pc-(Ptr)theROM;
      badCodeAddress=true;
    }
}

#ifdef BACKTRACE
INLINE void SetPCB(w32 addr, int type)
{
  /*  printf("SetPC: addr=%x\n",addr); */

  Ptr p=pc;

  
  if(((char)addr&1)!=0)
    { 
      exception=3;
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
      readOrWrite=16;
      badAddress=addr;
      badCodeAddress=true;

      return;
    }
  
  pc=(uw16*)((Ptr)theROM+(addr&ADDR_MASK));

  CheckTrace();
  AddBackTrace(p,type);


}

#endif 

INLINE void SetPC(w32 addr)
{
  /*  printf("SetPC: addr=%x\n",addr); */

  if(((char)addr&1)!=0)
    { 
      exception=3;
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
      readOrWrite=16;
      badAddress=addr;
      badCodeAddress=true;

      return;
    }
  
  pc=(uw16*)((Ptr)theROM+(addr&ADDR_MASK));
#ifdef TRACE
  CheckTrace();
#endif
}

#if 1
void ShowException(void){}
#else
void ShowException(void)
{    
  short i;
  int p1,p2,p4;
  unsigned char *p3;

  long xc=exception+3;

  if (exception==0) return;
 	

  p1=(xc);
  p2=((Ptr)pc-(Ptr)theROM-(xc==4? 0:2));
  if(xc==4)
    { 
      p3="Illegal code=";
      p4=(code);
    }
  else
    { 
      p3="";
      if(xc==3) p3="address error";
      if(xc==5) p3="divide by zero";
      if(xc==6) p3="CHK instruction";
      if(xc==7) p3="TRAPV instruction";
      if(xc==8) p3="privilege violation";
      if(xc==9) p3="trace xc";
      if(xc==10) p3="Axxx instruction code";
      if(xc==11) p3="Fxxx instruction code";
      if(xc>35 && xc<48) {p3="TRAP instruction"; p4=xc-35;}
      else p4=0;
    }
  printf("Exception %s %d at PC=%x, xx=%d\n",p3,p1,p2,p4);
}
#endif

extern int tracetrap;

#define UpdateNowRegisters()
#if 0
#define ExceptionIn(x)
#else
void ExceptionIn(char x)
{
  if (!tracetrap) return;

  printf("Entering TRAP #%d\n",x-32);
  DbgInfo();
}
#endif
#if 1
void ExceptionOut()
{
  if (!tracetrap) return;
  
  printf("RTE\n");
  DbgInfo();
}

#endif

void ExceptionProcessing()
{
  if(pendingInterrupt!=0 && !doTrace) ProcessInterrupts();
  if(exception!=0)
    {
      if(exception<32 || exception>36) /* tutte le eccezioni
					  tranne le trap 0-4 */
	{  
	  extraFlag=exception<3 || (exception>9 &&
				    exception<32) || exception>47;
	  if(!extraFlag) extraFlag=ReadLong(0x28050l)==0;
	  if(extraFlag)
	    {    
	      UpdateNowRegisters();
	      /*ShowException(); */
	      nInst=nInst2=0;
	    }
	}
      if(!supervisor)
	{ 
	  usp=(*sp);
	  (*sp)=ssp;
	}
      ExceptionIn(exception);
      (*sp)-=6;
      WriteLong((*sp)+2,(w32)pc-(w32)theROM);
      WriteWord((*sp),GetSR());
      SetPCX(exception);
      if(exception==3) /* address error */
	{ 
	  (*sp)-=8;
	  WriteWord((*sp)+6,code);
	  WriteLong((*sp)+2,badAddress);
	  WriteWord((*sp),BusErrorCode(badCodeAddress? 2:1));
	  badCodeAddress=false;
	  if(nInst) exception=0;
	} else exception=0; /* allow interrupts */
      extraFlag=false;
      supervisor=true;
      trace=false;
    }
   if(doTrace)
    {      
      if(!supervisor)
	{ 
	  usp=(*sp);
	  (*sp)=ssp;
	}
      ExceptionIn(9);
      (*sp)-=6;
      WriteLong((*sp)+2,(Ptr)pc-(Ptr)theROM);
      WriteWord((*sp),GetSR());
      SetPCX(9);
      if(nInst==0) exception=9;       /* no interrupt allowed here */
      supervisor=true;
      /*doTrace=*/trace=false;
      extraFlag=false;
      stopped=false;
    }
  doTrace=trace;
  if(doTrace) {nInst2=nInst;nInst=1;}
  if(pendingInterrupt!=0 && !doTrace)   /* delay interrupt after trace exception */
    {
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
    }
	
}


/******************************************************************/
/* now read in ReadByte etc macros */


#ifdef USE_VM
#include "iexl_general.h"
#else
#define D_ISREG
#include "memaccess.h"
#endif


/*******************************************************************/

#if 1

inline w32 GetEA_m2(short r)
{   
  return  aReg[r];
}

w32 inline GetEA_m5(short r)
{     
  return aReg[r]+(w16)RW(pc++);
}

w32 GetEA_m6(short r)
{
  w16 displ;

  displ=(w16)RW(pc++);
  if((displ&2048)!=0)
    return *(((w32*)((Ptr)reg+((displ>>10)&60)))) + aReg[r] + (w32)((w8)displ);
  /*        register access */
  return (w32) (*((w16*)((Ptr)reg+RWO+((displ>>10)&60)))) + aReg[r] + (w32)((w8)displ);
}

w32 GetEA_m7(short r)
{   
  w16 displ;
  switch(r) {
  case 0:displ=(w16)RW(pc++);
    return displ;
  case 1:pc+=2;
    return  RL((w32*)(pc-2));/* *((w32*)(pc-2));*/
  case 2:displ=(w16)RW(pc++);
    return (Ptr)pc-(Ptr)theROM-2+displ;
  case 3:
    displ=(w16)RW(pc++);
    if((displ&2048)!=0) return reg[(displ>>12) & 15]+
			  (Ptr)pc-(Ptr)theROM-2+(w32)((w8)displ);
    return (w32)((w16)(reg[(displ>>12) & 15]))+
      (Ptr)pc-(Ptr)theROM-2+(w32)((w8)displ);
  }
  exception=4;
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
  return 0;
}

vml w32 GetEA_m7_3(void)
{     
  w16 displ;

  displ=(w16)RW(pc++);
  if((displ&2048)!=0) return reg[(displ>>12) & 15]
			+(Ptr)pc-(Ptr)theROM-2+(w32)((w8)displ);
  return (w32)((w16)(reg[(displ>>12) & 15]))+
    (Ptr)pc-(Ptr)theROM-2+(w32)((w8)displ);
}


w32 GetEA_mBad(short r)
{    
  exception=4;
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
  return 0;
}

vml inline w8 GetFromEA_b_m0(void)
{ 
  return (w8)(reg[code&7]);
}

vml w8 GetFromEA_b_mBad(void)
{    
  exception=4;
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
  return 0;
}

vml inline w8 GetFromEA_b_m2(void)
{    
  return ReadByte(aReg[code&7]);
}

vml inline w8 GetFromEA_b_m3(void)
{  
  register w8 b;
  register short r;
  uw32 addr;
  
  r=code&7;
  addr=aReg[r]++;
  if(r==7) aReg[r]++;
  b=ReadByte(addr);

  return b;
}

/* added as special case for cmpm */
vml inline w8 GetFromEA_rb_m3(short r)
{  
  register w8 b;
  uw32 addr;
  
  addr=aReg[r]++;
  if(r==7) aReg[r]++;
  b=ReadByte(addr);

  return b;
}
vml inline w16 GetFromEA_rw_m3(short r)
{  
  uw32 addr;

  addr=aReg[r];
  aReg[r]+=2; 
  
  return ReadWord(addr);
}
vml inline w32 GetFromEA_rl_m3(short r)
{  
  uw32 addr;
  
  addr=aReg[r];
  aReg[r]+=4;

  return ReadLong(addr);
}
/****/

vml inline w8 GetFromEA_b_m4(void)
{    
  register short r;
      
  r=code&7;
  if(r==7) aReg[r]--;
  return ReadByte(--aReg[r]);
}

vml inline w8 GetFromEA_b_m5(void)
{   
  return ReadByte(aReg[code&7]+(w16)RW(pc++));
}

vml inline w8 GetFromEA_b_m6(void)
{    
  return ReadByte(GetEA_m6(code&7));
}

vml  w8 GetFromEA_b_m7(void)
{   
  register short r;
  register w32 addr;

  r=code&7;
  switch(r){
  case 0:
    return ReadByte((w32)((w16)RW(pc++)));
  case 1:
    /*addr=*((w32*)pc);*/
    addr=RL((w32*)pc);
    pc+=2;
    /*asm volatile("");*/
    return ReadByte(addr);
  case 2:
    addr=(w32)pc-(w32)theROM+(w16)RW(pc);
    pc++;
    return ReadByte(addr);
  case 3:
    return ReadByte(GetEA_m7_3());
  case 4:
    pc++;
    return RB((w8*)pc-1);
  }
  exception=4;
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
  return 0;
}

vml inline w16 GetFromEA_w_m0(void)
{    
  return (w16)(reg[code&7]);
}

vml inline w16 GetFromEA_w_m1(void)
{    
  return (w16)(aReg[code&7]);
}

vml inline w16 GetFromEA_w_m2(void)
{    
  return ReadWord(aReg[code&7]);
}

vml inline w16 GetFromEA_w_m3(void)
{   
  register w16 t;
  register short r;
  uw32 addr;
  
  r=code&7;
  addr=aReg[r];
  aReg[r]+=2;
  t=ReadWord(addr);

  return t;
}

vml inline w16 GetFromEA_w_m4(void)
{    
  return ReadWord(aReg[code&7]-=2);
}

vml inline w16 GetFromEA_w_m5(void)
{    
  return ReadWord(aReg[code&7]+(w16)RW(pc++));
}

vml w16 GetFromEA_w_m6()
{   
  w16 displ;
  displ=(w16)RW(pc++);
  return ReadWord(((displ&2048)!=0)? 
		  (*((w32*)((Ptr)reg+((displ>>10)&60)))+
		     aReg[code&7]+(w32)((w8)displ)) :
		  (w32)*(((w16*)((Ptr)reg+RWO+((displ>>10)&60))))+
		     aReg[code&7]+(w32)((w8)displ));
}

vml w16 GetFromEA_w_m7(void)
{      
  register short r;
  register w32 addr;

  r=code&7;
  switch(r){
  case 0:
    return ReadWord((w32)((w16)RW(pc++)));
  case 1:
    addr=RL((w32*)pc);
    pc+=2;
    /*asm volatile("");*/
    return ReadWord(addr);
  case 2:
    addr=(w32)pc-(w32)theROM+(w16)RW(pc);
    pc++;
    return ReadWord(addr);
  case 3:
    return ReadWord(GetEA_m7_3());
  case 4:
    return (w16)RW(pc++);
  }
  exception=4;
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
  return 0;
}

vml inline w32 GetFromEA_l_m0(void)
{    
  return reg[code&7];
}

vml inline w32 GetFromEA_l_m1(void)
{     
  return aReg[code&7];
}

vml inline w32 GetFromEA_l_m2(void)
{     
  return ReadLong(aReg[code&7]);
}

vml inline w32 GetFromEA_l_m3(void)
{     
  register w32 t;
  register short r;
  uw32 addr;
  
  r=code&7;
  addr=aReg[r];
  aReg[r]+=4;
  t=ReadLong(addr);

  return t;
}

vml inline w32 GetFromEA_l_m4(void)
{     
  return ReadLong(aReg[code&7]-=4);
}

vml inline w32 GetFromEA_l_m5(void)
{     
  return ReadLong(aReg[code&7]+(w16)RW(pc++));
}

vml inline w32 GetFromEA_l_m6(void)
{    
  return ReadLong(GetEA_m6(code&7));
}

vml w32 GetFromEA_l_m7(void)
{    
  register short r;
  register w32 addr;

  r=code&7;
  switch(r){
  case 0:
    return ReadLong((w32)((w16)RW(pc++)));
  case 1:
    addr=RL((w32*) pc);/* *((w32*)pc); */
    pc+=2;
    /*asm volatile("");*/
    return ReadLong(addr);
  case 2:
    addr=(w32)pc-(w32)theROM+(w16)RW(pc);
    pc++;
    return ReadLong(addr);
  case 3:
    return ReadLong(GetEA_m7_3());
  case 4:
    pc+=2;
    return RL((w32*)(pc-2));/* *((w32*)(pc-2));*/
  }
  exception=4;
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
  return 0;
}

vml void PutToEA_b_m0(short r,w8 d)
{   
  *( (w8*)( (Ptr)(&(reg[r])) + RBO ) )=d;
}

vml void PutToEA_b_mBad(short r,w8 d)
{    
  exception=4;
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
}

vml inline void PutToEA_b_m2(short r,w8 d)
{   
  WriteByte(aReg[r],d);
}

vml inline void PutToEA_b_m3(short r,w8 d)
{     
  uw32 addr=aReg[r];
  aReg[r]++;
  if(r==7) aReg[r]++;

  WriteByte(addr,d);
}

vml inline void PutToEA_b_m4(short r,w8 d)
{   
  if(r==7) aReg[r]--;
  WriteByte(--aReg[r],d);
}

vml inline void PutToEA_b_m5(short r,w8 d)
{    
  WriteByte(aReg[r]+(w16)RW(pc++),d);
}

vml inline void PutToEA_b_m6(short r,w8 d)
{   
  WriteByte(GetEA_m6(r),d);
}

vml inline void PutToEA_b_m7(short r,w8 d)
{     
  WriteByte(GetEA_m7(r),d);
}

vml inline void PutToEA_w_m0(short r,w16 d)
{
  *( (w16*)( (Ptr)(&(reg[r])) + RWO ) )=d; 
}

vml inline void PutToEA_w_m1(short r,w16 d)
{   
  *( (w16*)( (Ptr)(&(aReg[r])) + RWO ) )=d; 
}

vml inline void PutToEA_w_m2(short r,w16 d)
{     
  WriteWord(aReg[r],d);
}

vml inline void PutToEA_w_m3(short r,w16 d)
{     
  uw32 addr=aReg[r];

  aReg[r]+=2;
  WriteWord(addr,d);
}

vml inline void PutToEA_w_m4(short r,w16 d)
{    
  WriteWord(aReg[r]-=2,d);
}

vml inline void PutToEA_w_m5(short r,w16 d)
{     
  WriteWord(aReg[r]+(w16)RW(pc++),d);
}

vml inline void PutToEA_w_m6(short r,w16 d)
{     
  WriteWord(GetEA_m6(r),d);
}

vml inline void PutToEA_w_m7(short r,w16 d)
{    
  WriteWord(GetEA_m7(r),d);
}

vml inline void PutToEA_l_m0(short r,w32 d)
{     
  reg[r]=d;
}

vml inline void PutToEA_l_m1(short r,w32 d)
{    
  aReg[r]=d;
}

vml inline void PutToEA_l_m2(short r,w32 d)
{    
  WriteLong(aReg[r],d);
}

vml inline void PutToEA_l_m3(short r,w32 d)
{    
  uw32 addr=aReg[r];
  aReg[r]+=4;
  WriteLong(addr,d);
}

vml inline void PutToEA_l_m4(short r,w32 d)
{    
  WriteLong(aReg[r]-=4,d);
}

vml inline void PutToEA_l_m5(short r,w32 d)
{   
  WriteLong(aReg[r]+(w16)RW(pc++),d);
}

vml inline void PutToEA_l_m6(short r,w32 d)
{   
  WriteLong(GetEA_m6(r),d);
}

vml inline void PutToEA_l_m7(short r,w32 d)
{   
  WriteLong(GetEA_m7(r),d);
}
#endif


/********************************************************************/

/* fetch and dispatch loop: 68K machine code version
void ExecuteLoop(void)  esecuzione di nInst istruzioni
{       void    *where;         pc in asm =E8 un nome riservato !!!

        where=&pc;
        asm{
                MOVEM.L   A2-A4,-(A7)
                MOVEA.L   where,A2
                LEA       nInst,A3
                MOVEA.L   table,A4
                BRA.S     @doLoop
loop:   MOVEA.L   (A2),A0
                ADDQ.L    #2,(A2)
                MOVEQ     #0,D0
                MOVE.W    (A0),D0
                MOVE.W    D0,code
                LSL.L     #2,D0
                MOVEA.L   0(A4,D0.L),A0
                JSR       (A0)
doLoop: SUBQ.L    #1,(A3)
                BGE.S     @loop
                TST.B     extraFlag
                BEQ.S     @endLoop
                MOVE.L    nInst2,(A3)
                JSR       ExceptionProcessing
                TST.L     (A3)
                BGT.S     @loop
endLoop: MOVEM.L   (A7)+,A2-A4
                }
}
*/



/*  */

extern volatile int doPoll;

#ifdef FASTLOOP
static int itable_valid=0;

void ExecuteLoop(void)
{
  static void *itable[65536];
#ifdef SPARC
  register void **itab asm("l7");
#else
  register void **itab;
#endif

#if  1 /*MANYREGS*/
  w32 *aReg=reg+8;
  w32* reg=aReg-8;
  w32 (**GetEA)(short) REGP1 = iexl_GetEA;
  w8  (**GetFromEA_b)(void) = iexl_GetFromEA_b;
  w16 (**GetFromEA_w)(void) = iexl_GetFromEA_w;
  w32 (**GetFromEA_l)(void) = iexl_GetFromEA_l;
  void (**PutToEA_b)(short,w8) REGP2 = iexl_PutToEA_b;
  void (**PutToEA_w)(short,w16) REGP2 = iexl_PutToEA_w;
  void (**PutToEA_l)(short,w32) REGP2 = iexl_PutToEA_l;
  Cond (**ConditionTrue)(void) = ll_ConditionTrue;
  w32 *theROM=ll_theROM;
#else
#define GetFromEA_b iexl_GetFromEA_b
#define GetFromEA_w iexl_GetFromEA_w
#define GetFromEA_l iexl_GetFromEA_l
#define PutToEA_b iexl_PutToEA_b
#define PutToEA_w iexl_PutToEA_w
#define PutToEA_l iexl_PutToEA_l
#endif
  
  itab=itable;
  
#define IE_XL

  goto run_it; 
  
  /*#include "iexl_general.h"*/
#if 0

#endif 0
#include "instructions_ao.c"    /* include instructions */
#include "instructions_pz.c"
  /*#include "iexl_ug.h"*/

run_it:
  if (!itable_valid)
    {
#define IE_XL_II 
#include "Init.c"
      /*XSetTable(itable);*/
      itable_valid=1;
    } 
  theROM=ll_theROM;
  ENTER_IEXL;                  /* load vars into regs etc .*/

nextI: 
  if (--nInst>=0)
    {
#ifdef TRACE
      if (pc>tracelo) DoTrace();
#endif
      /*DbgInfo();*/
      
      goto *itab[code=RW(pc++)];
    } 
  
#ifdef 0
  if (regEmux)
    {
      nInst= (extraFlag ? 0 : reInst);     
      vm_regemu();
 
      goto nextI;
    }
#endif  

  if (doPoll) dosignal();

  if(extraFlag)
    {
      nInst=nInst2;
      ExceptionProcessing();
      if(nInst>0) goto nextI;
    }
}

#else
void ExecuteLoop(void)  /* fetch and dispatch loop */
{     
  register void           (**tab)(void);

  tab=table;

rep: 
  while(--nInst>=0)    
    {

#ifdef TRACE 
      if (pc>tracelo) DoTrace();
#endif
      
      tab[code=RW(pc++)]();
    }
	
  if (doPoll) dosignal();

  if(extraFlag)
    {
      nInst=nInst2;
      ExceptionProcessing();
      if(nInst>0) goto rep;
    }
}
#endif

void ExecuteChunk(long n)       /* execute n emulated 68K istructions */
{  
  ll_theROM=theROM;
#ifdef 0
  left_exl=1;
#endif

#ifdef USE_VM
  if(!vm_ison)
    vm_on();
#endif
  
  if((long)pc&1) return;

 restart:

  extraFlag=false;
  ProcessInterrupts();

  if(stopped) return;
  exception=0;
  extraFlag=extraFlag || trace || doTrace;
  nInst=n;
  if(extraFlag)
    { 
      nInst2=nInst;
      nInst=0;
    }

#ifdef USE_VM
  if(sigsetjmp(instr_retry_catch,1)) 
    {
      /* make sure register variables are what they ought to be */
      restore_state(&res_state);  
      table[code=RW(pc++)]();
      goto restart;
    }
#endif

  ExecuteLoop();  
#ifdef 0
  left_exl=1;
#endif
}




void InitialSetup(void) /* 68K state when powered on */
{ 
  ssp=*sp=RL(&theROM[0]);
  SetPC(RL(&theROM[1]));
  printf("initial PC=%x SP=%x\n",(void*)pc-(void*)theROM,ssp);
	
  iMask=7;
  supervisor=true;
  trace=doTrace=false;
  exception=0;
  extraFlag=false;
  pendingInterrupt=0;
  stopped=false;
  badCodeAddress=false;
}

 
void FrameInt(void)
{     
  if((intReg&8)!=0) /* controlla che sia abilitato */
    { 
      theInt=8;
      intReg^=8;
      pendingInterrupt=2;
      *((uw8*)theROM+0x280a0l)=16;
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
    }
}





















