/*              Copyright (c) 1995 Daniele Terdina
*/

#ifdef USE_VM
#include <setjmp.h>
#endif

#undef BIG_ENDIAN

#if defined(sparc) || defined(__sparc)
#define SPARC
#endif

#if defined(__hp9000s800) || defined(hppa)
#define HPPA
#endif

#if defined(mips)
#define MIPS
#endif

#if defined(__alpha__)
#define ALPHA
#endif

extern void             (**table)(void);

typedef int OSErr;
extern char *release;
extern char *uqlx_version;

#ifndef NULL
#define NULL (void *)0
#endif

extern int gKeyDown, shiftKey, controlKey, optionKey, alphaLock, altKey;

extern w32              reg[16];
extern w32              usp,ssp;

#ifdef SPARC
register uw16  *pc asm("g5");
register uw16  code asm("g6");
register int   nInst asm("g7");
#define GREGS
#define MANYREGS
#endif

#ifdef HPPA
register uw16  *pc asm("r5");
register uw16  code asm("r6");
register int   nInst asm("r7");
#define GREGS
#define MANYREGS
#endif

#ifdef MIPS
register uw16  *pc asm("$23");
register uw16  code asm("$22");
register int   nInst asm("$21");
#define GREGS
#define MANYREGS
#endif

#ifdef ALPHA
#define HUGE_POINTER
#define MANYREGS
#endif

#ifndef GREGS
extern uw16 *pc;
extern uw16 code;
extern int nInst;
#endif

#define gPC  pc
#define gUSP usp
#define gSSP ssp

#define ADDR_MASK    0xffffff
#define ADDR_MASK_E  0xfffffe

#ifdef TRACE
extern uw16 *tracelo; 
extern uw16 *tracehi;
extern void CheckTrace(void);
extern void TraceInit(void);
extern void DoTrace(void);
#endif

extern int   nInst2;
extern Cond             trace,supervisor,xflag,negative,zero,overflow,carry;
extern char             iMask;
extern Cond             stopped;
extern volatile char    pendingInterrupt;

extern w32              *sp;
extern w32              *aReg;

extern w32              *theROM;
extern w32              *ramTop;
extern w32              RTOP;
extern short            exception;
extern w32              badAddress;
extern w16              readOrWrite;
extern w32              dummy;
extern Ptr              dest;
#ifndef VM_SCR
extern Cond             isDisplay;
#endif
extern Cond             isHW;
extern w32              lastAddr;
extern volatile Cond    extraFlag;
extern volatile w8      intReg;
extern volatile w8      theInt;

extern char             *RamMap;
extern char             dispScreen;
extern Cond             dispMode;
extern Cond             badCodeAddress;

#ifdef USE_VM
extern sigjmp_buf instr_retry_catch;
#endif

extern w32  displayFrom;
extern w32  displayTo;

extern int isMinerva;

#if 0 /*__i486__*/
#define REGP1 __attribute__ ((regparm(1)))
#define REGP2 __attribute__ ((regparm(2)))
#else
#define REGP1
#define REGP2
#endif

w8 GetFromEA_rb_m3(short );
w16 GetFromEA_rw_m3(short );
w32 GetFromEA_rl_m3(short );


extern w32      (*GetEA[8])(short) REGP1;      /**/
extern w8       (*GetFromEA_b[8])(void);
extern w16      (*GetFromEA_w[8])(void);
extern w32      (*GetFromEA_l[8])(void);
extern void (*PutToEA_b[8])(short,w8)  REGP2;  /**/
extern void (*PutToEA_w[8])(short,w16)  REGP2; /**/
extern void (*PutToEA_l[8])(short,w32)  REGP2; /**/
extern Cond (*ConditionTrue[16])(void) ;


#define PROTO_R1 (w32 (*)(short) REGP1)
#define PROTO_R2_B (void (*)(short,w8) REGP2) 
#define PROTO_R2_W (void (*)(short,w16) REGP2) 
#define PROTO_R2_L (void (*)(short,w32) REGP2) 

#define GET_EA(_mode_,_code_) ( (PROTO_R1 GetEA[(_mode_)]) (_code_))
#define PUT_TOEA_B(_mode_,_code_,_val_)  ((PROTO_R2_B PutToEA_b[(_mode_)])((_code_),(_val_)))
#define PUT_TOEA_W(_mode_,_code_,_val_)  ((PROTO_R2_W PutToEA_w[(_mode_)])((_code_),(_val_)))
#define PUT_TOEA_L(_mode_,_code_,_val_)  ((PROTO_R2_L PutToEA_l[(_mode_)])((_code_),(_val_)))

w8 ReadHWByte(w32 )  REGP1;
w8 ReadByte(w32 ) REGP1;
w16 ReadWord(w32 ) REGP1;
w32 ReadLong(w32 ) REGP1;
void WriteByte(w32 ,w8 ) REGP2;
void WriteWord(w32 ,w16 ) REGP2;
void WriteLong(w32 ,w32 ) REGP2;
w8 ReadDispByte(w32 );
w16 ReadDispWord(w32 );
w32 ReadDispLong(w32 );
void ValidateDispByte(w32 );
w16 GetSR(void);
void PutSR(w16 ) REGP1;
w16 BusErrorCode(w16 );
void SetPC(w32 )  REGP1;
void SetPCX(int )  REGP1;
w8      GetFromEA_b_m3(void);
w8      GetFromEA_b_m4(void);
w16     GetFromEA_w_m3(void);
w16     GetFromEA_w_m4(void);
w32     GetFromEA_l_m3(void);
w32     GetFromEA_l_m4(void);
w8 ModifyAtEA_b(short ,short )  REGP2;
w16 ModifyAtEA_w(short ,short ) REGP2;
w32 ModifyAtEA_l(short ,short ) REGP2;
void RewriteEA_b(w8 )  REGP1;
void RewriteEA_w(w16 ) REGP1;
void RewriteEA_l(w32 ) REGP1;
void FrameInt(void);

void ExceptionIn(char);
void ExceptionOut(void);
void UpdateNowRegisters(void);

Boolean IPC_Command(void);
void WriteMdvControl(w8);

#define LongFromByte(__d__) ((w32)((w8)(__d__)))
#define LongFromWord(__d__) ((w32)((w16)(__d__)))
#define WordFromByte(__d__) ((w16)((w8)(__d__)))

#define nil (void*)0
int Error;
#define gError Error


extern long pagesize;
extern int pageshift;
extern char *scrModTable;
extern int sct_size;
extern char * oldscr;


#ifdef NO_PSHIFT
#define PAGEI(_x_)  ((int)(_x_)/pagesize)
#define PAGEX(_x_)  ((int)(_x_)*pagesize)
#else
#define PAGEI(_x_)  ((int)(_x_)>>pageshift)
#define PAGEX(_x_)  ((int)(_x_)<<pageshift)
#endif
#include "cond.h"
#include "trace.h"
#include "iexl.h"

#ifdef SPARC
#define HOST_ALIGN 4
#define BIG_ENDIAN
#endif

#ifdef sgi
#define HOST_ALIGN 4
#define BIG_ENDIAN
#endif

#if defined(HPPA) 
#define BIG_ENDIAN
#define HOST_ALIGN 4
#endif

#if !defined(HPPA) && defined(hpux)
/* good guess it is a 680x0 */
#define BIG_ENDIAN
#define HOST_ALIGN 2
#endif


#define WB(_addr_,_val_)(*(uw8*)(_addr_)=(_val_))
#define RB(_addr_) (*(uw8 *)(_addr_))


extern const big_endian;

#ifdef BIG_ENDIAN
#if 0
static inline void  WW(uw16 *addr, w16 d)
{
  *(uw16*)addr=d;
}
static inline uw16 RW(uw16 *addr)
{
  return *addr;
}
#else
#define WW(_addr_,_val_) (*(uw16*)(_addr_)=(_val_))
#define RW(_addr_) (*(uw16*)(_addr_))
#endif


static inline void WL(w32 *addr,w32 d)
{
#if (HOST_ALIGN>2)
  if ((long)addr&2)
    {
      *(uw16*)addr=d>>16;
      *(((uw16*)addr)+1)=d&0xffff;
    }
  else
#endif
    *addr=d;
}
static inline uw32 RL(w32 *addr)
{
#if (HOST_ALIGN>2)
  if ((long)addr&2)
    return (w32) (((*(uw16*)addr)<<16)|((*(uw16*)(2+(long)(addr)))));
  else
#endif
    return *addr;
}

#else
/* little endian stuff comes here */

#if defined(__i486__) 

static inline uw16 RW(uw16 *s)
{	register uw16 x=*s;
	asm ( "rolw $8,%0\n" : "=c" (x) : "c" (x));
	return x;
}
static inline uw32 RL(uw32 *s)
{	register uw32 y=*s,x;
	asm ( "bswap %0\n" : "=S" (x) : "S" (y));
	return x;
}
static inline void WW(uw16 *d, uw16 v)
{	asm ( 	"xchgb %%ch,%%cl\n\t"
		"movw %%cx,(%%esi)\n"   
        : 
        : "c" (v), "S" (d)
        : "cx");
}
static inline void WL(uw32 *d, uw32 v)
{	asm (	"bswap %0\t\n"
		"movl %0,(%1)\n"   
        : 
        : "S" (v), "D" (d)
        );
}


#else /* i486 */

static inline uw16 RW(uw16 *s)
{
#if SWAP_LOAD_IN_MEMORY
	uw16* x = *(s);
	return ((x&0xff)<<8)|((x>>8)&0xff);
#else
	w8 *ss = (w8 *)s;
	uw8 *su = (uw8 *)s;
	return ((*(ss))<<8)|(*(su+1));
#endif
}
static inline uw32 RL(uw32 *s)
{
#if SWAP_LOAD_IN_MEMORY
	uw32 x = *(s);
	return ((x&0xff)<<24)|((x&0xff00)<<8)|((x>>8)&0xff00)|((x>>24)&0xff);
#else
	w8 *ss = (w8 *)s;
	uw8 *su = (uw8 *)s;
	return ((*(ss))<<24)|((*(su+1))<<16)
			|((*(su+2))<<8)|((*(su+3)));
#endif
}

static inline void WW(uw16 *d, uw16 v)
{
#if SWAP_STORE_IN_MEMORY
	*d=((v&0xff)<<8)|((v>>8)&0xff);
#else
	w8 *ds = (w8 *)d;
	uw8 *du = (uw8 *)d;
	*ds=v>>8;
	*(du+1)=v&0xff;
#endif
}

static inline void WL(uw32 *d, uw32 v)
{
#if SWAP_STORE_IN_MEMORY
	*d=((v&0xff)<<24)|((v&0xff00)<<8)|((v>>8)&0xff00)|((v>>24)&0xff);
#else
	w8 *ds = (w8 *)d;
	uw8 *du = (uw8 *)d;
	*ds= v>>24;
	*(du+1)=(v>>16)&0xff;
	*(du+2)=(v>>8)&0xff;
	*(du+3)=v&0xff;
#endif
}

#endif 



#endif /* BIG_ENDIAN */

#define dbginfo(format,args...) {printf(format, ## args);\
                                 DbgInfo();}

		     
#ifdef BIG_ENDIAN
#define RWO 2
#define UW_RWO 0
#define RBO 3
#define MSB_W  2
#define MSB_L  0
#else
#define RWO 0
#define UW_RWO 2
#define RBO 0
#define MSB_W  1
#define MSB_L  3
#endif

#ifdef HUGE_POINTER
void static inline SET_POINTER(w32*_addr_,void *_val_) 
{ 
  WL(_addr_,(((long)_val_)>>32)&0xffffffff);
  WL(_addr_+4,((long)_val_)&0xffffffff);
}
static inline void *GET_POINTER(w32* _addr_)  
{
  return ((void *) ((((long)RL(_addr_))<<32 )| (long)RL(_addr_+4)));
}
#else
#define SET_POINTER(_addr_,_val_)  (WL(_addr_,(w32)_val_)) 
#define GET_POINTER(_addr_)  ((void *)RL(_addr_))
#endif




extern void QLtrap(int ,int ,int );
extern void QLvector(int , int );


#include "QL_screen.h"

#ifdef BIG_ENDIAN
static const int big_endian=1;
#else
static const int big_endian=0;
#endif

extern int script;
extern Cond doTrace;

#if defined(USE_VM) && !defined(VM_SCR)
#define MARK_SCREEN
#endif

#if defined(USE_VM) || defined(VM_SCR)
void prepChangeMem(w32, w32);
#else
#define prepChangeMem
#endif

#define inline
