#include <sys/types.h>
#ifndef __EMX__
#include <sys/mman.h>
#endif
#include <sys/stat.h>
#include <sys/time.h>
#include <time.h>

#include <fcntl.h> 
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>

#ifdef __EMX__
#define INCL_DOSPROCESS
#include <os2emx.h>
void dotime(void *);
#endif


#include "QLtypes.h"
#include "QL68000.h"
#include "xcodes.h"  
#include "QL_config.h" 
#include "QInstAddr.h"


#if defined(VM_SCR) || defined(USE_VM)
#include "vm.h"
#endif

#include "unix.h"
#include "boot.h"

#define TIME_DIFF    283996800
void GetDateTime(w32 *);

#ifdef VTIME 
int qlttc=50;
int qltime=0;
int qitc=10;
#endif

int ux_boot=0;
int ux_bfd=0;
char *ux_bname="";


int UQLX_optind;
int UQLX_argc;
char **UQLX_argv;


#define min(_a_,_b_) (_a_<_b_ ? _a_ : _b_)
#define max(_a_,_b_) (_a_>_b_ ? _a_ : _b_)

int rx1,rx2,ry1,ry2,finishflag,doscreenflush;
static int QLdone=0;

#ifdef __EMX__ /*philip*/
int timerthread;
#endif


extern void FlushDisplay(void);


#ifdef AUTO_BOOT
void btrap3(void);
#endif

extern void SchedulerCmd(void);
extern void KbdCmd(void);


#ifndef XAW
extern void process_events(void);
#endif

int script=0;
int redir_std=0;

int scrcnt=0;
volatile int doPoll=0;
#ifdef VTIME
volatile poll_req=0;   /* debug only */
#endif
int noints=0;
int schedCount=0;
extern int min_idle;
int HasDialog;

#if defined(VM_SCR) || defined(USE_VM)
#else
long pagesize=4096;
int pageshift=12;
#endif


int InitDialog()
{
  char buf[400],arg[100];
  char *p;
  int QMpid,bfpid;

#ifdef XAW
  return 0;
#else

  QMpid=getpid();
  sprintf(arg,"%d",QMpid);
  
  bfpid=fork();
  if (bfpid) return bfpid;
  
  strncpy(buf,IMPL,400); 
  p=buf+strlen(buf)-1;
  if (*p!='/') 
    strncat(buf,"/",400);
  strncat(buf,"ButtonFrame",400);
  execl(buf,buf,arg,NULL);
  perror("Sorry, could not exec() ButtonFrame");
  /*kill(QMpid,SIGUSR1);*/
  _exit(0);
#endif
}

#ifdef SHOWINTS
static long alrm_count=0;
static long a_ticks=0;
static long aa_cnt=0;
#endif

void dosignal()
{
  uw32 t;
  
  doPoll=0;

#ifdef 0 /*VTIME*/
  if (poll_req>1)
    printf("poll_req=%d in dosignal()\n",poll_req);
#endif
  

#ifndef XAW
  if (!script)
    process_events();
#endif

#ifdef SHOWINTS
  aa_cnt+=alrm_count;
  alrm_count=0;
  if (++a_ticks>49)
    {
      printf("received %d alarm signals, processed %d\n",aa_cnt,a_ticks);
      a_ticks=aa_cnt=0;
    }
#endif
    
  if(--scrcnt<0)
    {
      scrcnt=5;
      doscreenflush=1;
    }
  
#if 0
  pendingInterrupt=2; /* cause 50 Hz interrupt */
  theInt=1<<(7-4);
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
#else
#ifndef xx_VTIME
  FrameInt(); 
#endif

#if 0 
  vm_off();
  
  GetDateTime(&t);
  WriteByte(0x18021,theInt);
  WriteLong(0x18000,t);

  vm_on();
#endif
#endif
}

void cleanup(int err)
{
#ifndef XAW
  if(HasDialog>0)
    kill(HasDialog,SIGINT);
  if (!script)
    x_screen_close();
#endif
  CleanRAMDev("RAM");
  exit(err);
}


void oncc(int sig)
{
  printf("exiting\n");
  QLdone=1;
}

void signalTimer()
{
  doPoll=1;
#ifdef VTIME
  poll_req++;
#endif
  schedCount=0;
  /*if (nInst>10) nInst=10;*/
#ifdef SHOWINTS
  alrm_count++;
#endif
}


#if 1 /* ndef XAW */
void ontsignal(int sig)
{
  signalTimer();
}
#endif


void on_fat_int(int x)
{
    printf ("Terminate on signal %d\n", x);
    cleanup(1);
}


void init_timers()
{
#ifndef __EMX__
  struct itimerval val;
#endif

#ifndef VTIME   
#ifndef __EMX__ 
  val.it_value.tv_sec=0L;
  val.it_value.tv_usec=20000;
  
  val.it_interval=val.it_value;

#if 0/* defined( __linux__ ) && !defined(XAW)*/
  setitimer(ITIMER_PROF,&val,NULL);
#endif
  setitimer(ITIMER_REAL,&val,NULL);
#else /* EMX */
  timerthread=_beginthread(dotime,NULL,32767,NULL);
  DosSetPriority(PRTYS_THREAD,PRTYC_FOREGROUNDSERVER,PRTYD_MAXIMUM,timerthread);
#endif
#endif
}

InitDialogErr()
{
  HasDialog=-1;
  /* init_timers(); */
}

#ifdef __EMX__ /*philip*/
void dotime(void *x)
{
  while(1)
  {
    _sleep2(20);
    signalTimer();
  }
}
#endif

void init_signals()
{
  struct sigaction sac;
  long i;

  sigemptyset(&(sac.sa_mask));
#ifndef SUNOS
  sac.sa_flags=SA_NODEFER;
#endif

  for(i=1; i<=SIGUSR2;i++)
    {
      sac.sa_handler=oncc;
      sigaction(i,&sac,NULL);
    }

#if 1 /*ndef XAW*/
  sac.sa_handler=ontsignal;
#else 
  sac.sa_handler=signalTimer;
#endif
#if 0 /* defined(__linux__) && !defined(XAW) */
  sigaction(SIGPROF,&sac,NULL);  
#endif
  sigaction(SIGALRM,&sac,NULL);


#ifndef NSIG
#define NSIG _NSIG
#endif


  sac.sa_handler=on_fat_int;
  sigaction(SIGSEGV,&sac,NULL);
  sigaction(SIGBUS,&sac,NULL);
  sigaction(SIGILL,&sac,NULL);
  sigaction(SIGQUIT,&sac,NULL);

  sac.sa_handler=InitDialogErr;
  if (sigaction(SIGUSR1,&sac,NULL))
    perror("could not redefine SIGUSR1\n");

#if defined(VM_SCR) || defined(USE_VM)
#ifdef SPARC
  sac.sa_sigaction=segv_handler;  /* SUN seem to be the only on to do this..*/
#else
  sac.sa_handler=segv_handler;  /* SUN seem to be the only on to do this..*/
#endif

#ifdef SPARC
  sac.sa_flags=SA_SIGINFO;
#endif
  sigaction(SIGSEGV,&sac,NULL);
#ifdef SPARC
  sac.sa_sigaction=buserr_handler;
#else
  sac.sa_handler=buserr_handler;
#endif
  sigaction(SIGBUS,&sac,NULL);
#endif
}



int load_rom(char *,w32);


void ChangedMemory(int from, int to)
{
  int i;
  
  if ((from>=131072 && from<=0x28000) || (to>=131072 && to<=0x2800))
    {
      displayFrom= displayFrom ? min(displayFrom , from) : from;
      displayFrom=max(131072, displayFrom);
      
      displayTo= displayTo ? max(displayTo , to) : to;
      displayTo=min(0x28000, displayTo);
#if defined(VM_SCR) || defined(USE_VM)
      for (i=0; i<sct_size; i++) 
	scrModTable[i]=(i*pagesize+131072<=displayTo &&
			i*pagesize+131072>=displayFrom);
#endif
    }
}
 


void DbgInfo(void)
{
  int i;

  printf("DebugInfo: PC=%x, code=%x, SupervisorMode: %s USP=%x SSp=%x A7=%x\n",
	 (Ptr)pc-(Ptr)theROM, code,
	 (supervisor ? "yes" : "no" ),
	 usp,ssp,*sp);
  printf("Register Dump:\t Dn\t\tAn\n");
  for(i=0;i<8;i++)
    printf("%d\t\t%8x\t%8x\n",i,reg[i],aReg[i]);
}


long uqlx_tz;

#if 1
long ux2qltime(long t)
{
  return t+TIME_DIFF+uqlx_tz;/*-timezone+(daylight ? 3600 : 0);*/
}
#endif
long ql2uxtime(long t)
{
  return t-TIME_DIFF-uqlx_tz;
}
void GetDateTime(w32 *t)
{

  struct timeval tp;
#if 0
  struct tm ltime;
  struct tm gtime;
  time_t ut;
#endif

#ifndef VTIME  

  gettimeofday(&tp,(void*)0);
  *t=ux2qltime(tp.tv_sec);
#else
  *t=qltime;
#endif
}

void init_uqlx_tz()
{
  struct tm ltime;
  struct tm gtime;
  time_t ut;

  ut=time(NULL);
  ltime=*localtime(&ut);
  gtime=*gmtime(&ut);

  gtime.tm_isdst=ltime.tm_isdst;
  uqlx_tz=mktime(&ltime)-mktime(&gtime);
}


w32 ReadQlClock(void)
{
  w32 t;
  
  GetDateTime(&t);
  /*  printf("ReadQLClock %d\n",t); */
  
  return t;
}






int impopen(char *name,int flg,int mode)
{
  char buff[400],*p;
  int r,md;

#ifdef __EMX__
  md=mode | O_BINARY;
#else
  md=mode;
#endif
  
  if ((r=open(name,flg,md))!=-1)
    return r;
  
  if(*name == '~')
    {
      char *p = buff;
      strcpy(p, getenv("HOME"));
      strcat(p, name + 1);
      name = p;
    }
  
  return open(name,flg,md);
  
    
  strncpy(buff,IMPL,380);
  p=buff+strlen(buff);
  if (*(p-1)!='/') strcat(buff,"/");
  strncat(buff,name,400);
  
  return open(buff,flg,md);
}


int load_rom(char *name,w32 addr)
{ 
  struct stat b;
  int r;
  int fd;

  printf("read rom %s at addr %x\n",name,addr);
  
  fd=impopen(name,O_RDONLY,0); 
  if (fd<0) {
    perror("Warning: could not find ROM image' ");
    return 0; }

  fstat(fd,&b);
  if (b.st_size!=16384 && addr!=0) printf("Warning: ROM size of 16K expected, %s is %d\n",
			       name, b.st_size);

  r=read(fd,(Ptr)theROM+addr,b.st_size);
  if (r<0) {
    perror("Warning, could not load ROM \n");
    printf("name %s, addr %x, QDOS origin %x\n",name,addr,theROM);
    return 0; }
  printf("loaded %s \t\tat %x\n",name,addr);
  close(fd);
  
  return r;
}

int scr_planes=2;
int scr_width,scr_height;

int verbose=1;
char *RamMap;

#ifndef XAW
extern int shmflag;
#endif


#ifndef XSCREEN
void parse_screen(char *x)
{
  printf("sorry, '-g' option works only with XSCREEN enabled,\ncheck your Makefile\n"); 
}
#endif

#if 0
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
extern char *buf;
extern XImage *image;
extern Display *display;
extern Window imagewin;
extern GC gc;
#endif 


static char obuf[BUFSIZ];

void CoreDump()
{
  int fd,r;
  
  fd=open("qlcore",O_RDWR|O_CREAT,0666);
  if (fd<0) perror("coredump failed: read: :");
  if (fd>-1)
    {
      r=write(fd, theROM, 1024*1024);
      if (!r) perror("coredump failed: write: ");
      close(fd);
      if (r)
	printf("memory dump saved as qlcore\n");
    }
}

char *uqlx_version="0.00";

#include "uqlx_cfg.h"


void SetParams(int ac, char **av)
{
  char *rf;
  char sysrom[200];
  int  rl=0;
  int j,c; 
  int mem=-1, col=-1, hog=-1;
  int gg=0;
  
  setvbuf(stdout,obuf,_IOLBF,BUFSIZ);

  *sysrom=0;
  
#ifndef NO_GETOPT 
  while((c = getopt(ac,av,"f:mchr:o:s:b:g:")) != EOF)
  {
    switch(c)
      {
      case 'g':
	gg=0;
	parse_screen(optarg);
	break;
      case 'f':
	{
	  char temp[PATH_MAX];
	  sprintf(temp, "UQLX_CFG=%s", optarg);
	  putenv(temp);
	}
      break;
      case 'o':
	strcpy(sysrom,optarg);
	break;
      case 'm':
	col = 0;
	break;
      case 'c':
	col = 1;
	break;
      case 'r':
	mem = atoi(optarg);
	break;
      case 'h':
	hog = 11;
	break;
      case 's':
	script=1;
	redir_std=1;
	/* FALLTHRU */
      case 'b':
	{
	  int len;
	  
	  if (optarg && strcmp("",optarg))
	    {
	      ux_boot=2;
	      len=strlen(optarg);
	      ux_bname=malloc(len+2);
	      strncpy(ux_bname,optarg,len);
	      ux_bname[len]=10;
	      ux_bname[len+1]=0;
	    }
	    break;
	}
      }
  }

  UQLX_argc=ac;
  UQLX_argv=av;
  UQLX_optind=optind;

#else
  UQLX_argc=ac;
  UQLX_argv=av;
  UQLX_optind=1;
#endif


  QMParams();

  if (*sysrom) strcpy(QMD.sysrom,sysrom);
  else if( strcmp(av[0],"qm"))
    {
      if (strstr(av[0],"js")) 
	strcpy(QMD.sysrom,"js_rom");
      if (strstr(av[0],"min")) 
	strcpy(QMD.sysrom,"minerva_rom");
    }

  if (gg==0 && strstr(av[0],"x"))
    {
      if (strcmp(QMD.sysrom,"minerva_rom"))
	{
	  strcpy(QMD.sysrom,"minerva_rom");
	  printf("using Minerva ROM\n");
	}
      if (strstr(av[0],"xxx"))
	parse_screen(QMD.size_xxx);
      else
	if (strstr(av[0],"xx"))
	  parse_screen(QMD.size_xx);
	else
	  parse_screen(QMD.size_x);
    }
  
  
  if(mem != -1) QMD.ramtop = mem;
  if(col != -1) QMD.color = col;
  if(hog != -1) QMD.cpu_hog=1;
  
  if(QMD.cpu_hog) min_idle=20000;
  else min_idle=5;
  
  RTOP=QMD.ramtop*1024;
  /*  RTOP=RTOP&&(~65535l);*/


}

void uqlxInit()
{
  char *rf;
  int  rl=0;
  void *tbuff;
  int j,c;
  int mem=-1, col=-1, hog=-1;


  rx1=0;rx2=qlscreen.xres-1;ry1=0;ry2=qlscreen.yres-1;finishflag=0;

  printf("*** QL Emulator v%s ***\nrelease %s\n\n",uqlx_version,release);
  tzset();

  /*RTOP=1024*1024;*/

#if defined(VM_SCR) || defined(USE_VM)
  vm_init();
#else
  theROM=malloc(RTOP);
  if (theROM==NULL)
    {
      printf("sorry, not enough memory for a %dK QL\n",RTOP/1024);
      exit(1);
    }
#endif
  
  RamMap=malloc((1024*1024*1024)>>15);
  tbuff=malloc(65536*sizeof(void *));
  {
      char roms[PATH_MAX];
      char *p;      

      if(rf=getenv("QL_ROM"))
	  rl=load_rom(rf,0);
      if (!rl)
      {
	  p = stpcpy(roms, QMD.romdir);
	  if(*(p-1) != '/')
	  {
	      *p++ = '/';
	  }
	  strcpy(p, QMD.sysrom);
	  
	  rl=load_rom(roms ,(w32)0);
	  if (!rl) 
	  {
	      fprintf(stderr,"Could not find qdos ROM image, exiting\n");
	      exit(2);
	  }
      }

      {
	  QMLIST *q;
	  for(q=QMD.romlist;q;q=q->next)
	  {
	      ROMITEM *c = q->udata;
	      strcpy(p, c->romname);
	      rl = load_rom(roms ,(w32) c->romaddr);
	      printf("ROM %s %s loaded at 0x%lx\n", 
		     c->romname, rl ? "" : "NOT", c->romaddr);
	  }
      }
  }


#ifndef XAW
  /*shmflag=0;*/
#endif

  init_uqlx_tz();  
  
#ifdef XAW
  if (script)
    {
      fprintf(stderr,"scriptmode mode supported with XAW\n");
      script=0;
    }
#endif


  init_signals();

#ifndef XAW
  if (!script && 1)
    {
      HasDialog=InitDialog();
    }
  
#endif

  AllocateDisk();
  
  init_iso();

  LoadMainRom();                        /* patch QDOS ROM*/

  if (isMinerva && RTOP>16384*1024) RTOP=16384*1024;
  if (!isMinerva && RTOP>4096*1024) RTOP=4096*1024;

  if (isMinerva)
    {
 
      qlscreen.xres=qlscreen.xres & (~(7));
      qlscreen.linel=qlscreen.xres/4;
      qlscreen.qm_len=qlscreen.linel*qlscreen.yres;/*0x8000;*/
      
      qlscreen.qm_lo=128*1024;
      qlscreen.qm_hi=128*1024+qlscreen.qm_len;
 
      if (qlscreen.qm_len % pagesize)
	{
	  printf("current geometry will waste %d bytes for alignment,\n",qlscreen.qm_len % pagesize);
	  printf("try another geometry achieve exact alignment\n");
#if 0
	  qlscreen.qm_len+=pagesize-1;
	  qlscreen.qm_len=PAGEX(PAGEI(qlscreen.qm_len));
#endif
	}
      
      if (qlscreen.qm_len>0x8000)
	{
	  /*qlscreen.qm_hi=RTOP;*/
	  /*qlscreen.qm_lo=qlscreen.qm_hi-qlscreen.qm_len;*/
	  /*RTOP=RTOP-qlscreen.qm_len;*/
	  if (PAGEX(PAGEI(RTOP-qlscreen.qm_len))<256*1024)
	    {
	      /*RTOP+=qlscreen.qm_len;*/
	      printf("sorry, not enough RAM for such a big screen\n");
	      goto bsfb;
	    }
	  qlscreen.qm_lo=PAGEX(PAGEI(RTOP-qlscreen.qm_len));
	  qlscreen.qm_hi=qlscreen.qm_lo+qlscreen.qm_len;
	  RTOP=qlscreen.qm_lo;
	}
    }
  else  /* JS doesn't handle big screen */
    {
    bsfb:
      qlscreen.linel=128;
      qlscreen.yres=256;
      qlscreen.xres=512;
      
      qlscreen.qm_lo=128*1024;
      qlscreen.qm_hi=128*1024+32*1024;
      qlscreen.qm_len=0x8000;
    }
  
#if defined(VM_SCR) || defined(USE_VM)
  vm_setscreen();
#endif

#ifndef XAW
  if (!script)
    x_screen_open(0);
#endif

  
#ifdef TRACE
  TraceInit();
#endif

#if 0
  mprotect((void *)theROM,1024*64,PROT_READ);
#endif

  EmulatorTable(tbuff);

  if (!isMinerva)
    {
      table[IPC_CMD_CODE]=UseIPC;        /* installl pseudoops */
      table[IPCR_CMD_CODE]=ReadIPC;
      table[IPCW_CMD_CODE]=WriteIPC;
      table[KEYTRANS_CMD_CODE]=QL_KeyTrans;
      
      table[FSTART_CMD_CODE]=FastStartup;
    }
  

  table[ROMINIT_CMD_CODE]=InitROM;
  table[MDVIO_CMD_CODE]=MdvIO;
  table[MDVO_CMD_CODE]=MdvOpen;
  table[MDVC_CMD_CODE]=MdvClose;
  table[MDVSL_CMD_CODE]=MdvSlaving;
  table[MDVFO_CMD_CODE]=MdvFormat;
  table[POLL_CMD_CODE]=PollCmd;


#ifdef SERIAL
#ifndef NEWSERIAL
  table[OSERIO_CMD_CODE]=SerIO;
  table[OSERO_CMD_CODE]=SerOpen;
  table[OSERC_CMD_CODE]=SerClose;
#endif
#endif
  table[SCHEDULER_CMD_CODE]=SchedulerCmd;
  if (isMinerva)
    {
      table[MIPC_CMD_CODE]=KbdCmd;
      table[KBENC_CMD_CODE]=KBencCmd;
    }

#if 1
  table[BASEXT_CMD_CODE]=BASEXTCmd;
#endif
  
#ifdef AUTO_BOOT
  table[0x4e43]=btrap3;
#endif

#if 0
  WW((uw16 *)((Ptr)theROM+0x4be4),0);            /* avoid booting MDV1_ */
  WW((uw16 *)((Ptr)theROM+0x4bde),0); 
#endif

  aReg=reg+8;
  sp=&reg[15];

  for(j=5;j<((1024*1024*1024)>>15);j++) RamMap[j]=0;                 /* empty        */
#if 1
  RamMap[0]=RamMap[1]=1;                          /* QL ROM       */
#else
  RamMap[0]=3;RamMap[1]=1;
#endif
  RamMap[2]=1;                              /* hidden emulator add-on */
  RamMap[3]=8;                                    /* QL I/O       */
#ifdef VM_SCR
  RamMap[4]=3;
#else
  RamMap[4]=7;                                    /* QL video buffer */
#endif
  for(j=5;j<(RTOP>>15);j++) RamMap[j]=3;          /* QL RAM */
	
  /*if(qc.romSpace) RamMap[24]=RamMap[25]=65; */      /* 4 expansion ROMs
    from C0000 */
  
  
  init_timers();
  
  InitialSetup();
  
  if (isMinerva)
    {
      reg[1]=RTOP&(~16383) | 1 | 2 | 4 | 16;
      SetPC(0x186);
    }
  
#if defined(VM_SCR) || defined(USE_VM)
  vm_on();
#ifdef USE_VM
  init_ixtable();
#endif
#else
  displayTo=qlscreen.qm_hi; /*131072+32768;*/
  displayFrom=qlscreen.qm_lo;/*131072;*/
#endif

  QLdone=0;
}

#ifndef XAW
void QLRun(void)
#else
Boolean CPUWork(void)
#endif
{
  int scrchange,i;

#ifndef XAW
 exec:
#endif
  
  /* printf("PC=%x\tSP=%x\tSSP=%x\n",(void*)pc-(void*)theROM,*sp,ssp); */
  /*DbgInfo(); */

  ExecuteChunk(1000);
  
  if (doscreenflush && !script)
    {
#if defined(VM_SCR) || defined(USE_VM)
      scrchange=0;
      for(i=0;i<sct_size;i++)scrchange=scrchange | scrModTable[i];
      
      if(scrchange)
#else
      if ((displayTo-displayFrom>0 && displayFrom!=0) || 
	  (rx1<=rx2 && ry1<=ry2))
#endif
	{
	  finishflag=1;
	  FlushDisplay();
	  displayFrom=0; 
	  displayTo=0; 
	  finishflag=0;
	  
	  doscreenflush=0;
	}  
    } 
#ifdef VTIME   
  if ((qlttc--)<=0)
    {
      qlttc=50;
      qltime++;
    }
  if ((qitc--)<0)
    {
      qitc=6;
      doPoll=1;
      /*FrameInt();*/   
      poll_req++;
      /*dosignal();*/
    }
#endif
  
#ifndef XAW
  if (!QLdone) 
    goto  exec;
  

  cleanup(0);
#else
  return 0;
#endif
}
