#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>
#include <sys/times.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>


#ifdef XAW
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#endif

#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#ifdef XAW
#define BOOLEAN_ALREADY_DEFINED
#endif
#include "QLtypes.h"
#include "QL68000.h"
#include "xcodes.h"
#include "QL.h"
#include "Qerror.h"

#include "QInstAddr.h"
#include "unix.h"
 
#ifdef XAW
extern Widget bitMap;
/*extern short xmouse;*/
#else
extern Display *display;
extern Window imagewin;
#endif

extern int schedCount;
extern int inside;

extern int sct_size;
extern char *scrModTable;

extern int rx1,rx2,ry1,ry2,finishflag,doscreenflush,scrcnt;
extern int script;

int min_idle=5;
int HasPTR=0;
int quickMouseUpdate=1;

#ifdef MOUSE
static w32 iscrdrv=0;
static w32 ptrscrdrv=0;
static int lastx=0;
static int lasty=0;
static int llastx=0;
static int llasty=0;
static int lastactive=0;
int invisible=0;

/*#define SCHEDULER_CMD_ADDR 0x14030*/

int getMouseX(){return ReadWord(ptrscrdrv+0x20);}
int getMouseY(){return ReadWord(ptrscrdrv+0x22);}
int ptractive(){return !ReadByte(ptrscrdrv+0x38);}

void setMouseX(int pos)
{
   WriteByte(ptrscrdrv+0x16,ReadByte(ptrscrdrv+0x16)+0);
  WriteWord(ptrscrdrv+0x20,pos);
}
void setMouseY(int pos)
{
  WriteByte(ptrscrdrv+0x16,ReadByte(ptrscrdrv+0x16)+0);
  WriteWord(ptrscrdrv+0x22,pos);
}
void setMouseXY(int x, int y)
{
  WriteByte(ptrscrdrv+0x16,ReadByte(ptrscrdrv+0x16)+1);
  WriteWord(ptrscrdrv+0x20,x);
  WriteWord(ptrscrdrv+0x22,y);
}

void print_mousepos()
{
  printf("mouse x,y = %4d,%4d\n",getMouseX(),getMouseY());
}


#endif



w32 getSCRdriver()
{
  return ReadLong(ReadLong(ReadLong(0x28078))+4);
}


/* link in scheduler task */
void SchedInit()
{
  reg[1]=0x10;
  reg[2]=0;
  QLtrap(1,0x18,2000000l);

  if (*reg==0)
    {
      Ptr p=(Ptr)theROM+aReg[0];
      p = p + 4;
	
      WL( p, SCHEDULER_CMD_ADDR);
      WW((Ptr)theROM+SCHEDULER_CMD_ADDR, SCHEDULER_CMD_CODE);
	
      QLtrap(1,0x1e,200000l);
    }
#ifdef MOUSE
  iscrdrv=getSCRdriver();
  printf("Initial Screen driver is %x\n",iscrdrv);
#endif
}
extern int MButtonDown;

#ifdef MOUSE
void QLButton(int bnr,int press)
{
  w32 saveA3;
  /*printf("Button %d %s\n",bnr,press?"pressed":"released");*/

  /*gKeyDown=press;*/

   WriteByte(ptrscrdrv+0xaf-0x18,0);

  if (HasPTR )
    {
      switch (bnr)
	{
	case 1: 
	  if (press) WriteByte(ptrscrdrv+0xaf-0x18,1);
	  WriteByte(ptrscrdrv+0x8c-0x18,0);
#if 0
	  if (press) queueCode(0,0x36);
	  KeyrowChg(0x36,press);
#endif
#if 0
	  KeyrowChg(0x36,press);
	  if (!isMinerva)
	    {
	      if (press) queueCode(0,0);
	      MButtonDown=gKeyDown=press;
	    }
#endif
	  
	  break;
	  /*  case 2: hot */
	case 2:
#if 0
	  aReg[2]=ReadLong(0x2804c);
	  reg[1]=ReadByte(ptrscrdrv+0x8d-0x18);
	  saveA3=aReg[3];
	  QLvector(0xe0,2000000l);
	  reg[1]=ReadByte(ptrscrdrv+0x8e -0x18);
	  QLvector(0xe0,2000000l);
	  reg[1]=0xc2;
	  QLvector(0xe0,2000000l);
	  aReg[3]=saveA3;
	  break;
#endif
	case 3: 
	  if (press) WriteByte(ptrscrdrv+0xaf-0x18,2);
	  WriteByte(ptrscrdrv+0x8c-0x18,0);
#if 0
	  if (press) queueCode(0,48);
	  KeyrowChg(48,press);
#endif
#if 0
	  KeyrowChg(48,press);
	  if (!isMinerva)
	    {
	      if (press) queueCode(0,0);
	      MButtonDown=gKeyDown=press;
	    }
#endif
	  break;
	}
    }
}
#endif

#ifdef MOUSE
void MouseTask()
{
  int x,y;
  static pendreset=0;
  w32 saveA3;

  saveA3=aReg[3];
  aReg[0]=0;
  
  /* lets hope PTR_GEN is the first screen driver extension that gets loaded */
  if (iscrdrv && !ptrscrdrv && iscrdrv!=getSCRdriver())
    {
      QLtrap(3,0x70,200000l);
      if (((w16)reg[0]) != 0)
	iscrdrv=getSCRdriver();
      else
	{
	  ptrscrdrv=getSCRdriver();
	  printf("PTRgen screen driver is %x\n",ptrscrdrv);
	  HasPTR=1;
	}
    }

  if (HasPTR)
    {
#if 0
      printf("Pointer activ: %s\n",ReadWord(ptrscrdrv+0x38)?"yes":"no");
      printf("Mouse Hotkey: %s\n",ReadByte(ptrscrdrv+0x15)?"yes":"no");
      printf("mouse counter: %d\n",ReadByte(ptrscrdrv+0x19));
      printf("PT_WAKE: %d\n",ReadByte(ptrscrdrv+0x34));
#endif
#if 0
      printf("PT_BSTAT: %d\t\t",ReadByte(ptrscrdrv+0x48-0x18));
      printf("PT_BSUPP: %d\t\t",ReadByte(ptrscrdrv+0x49-0x18));
      printf("PT_BPRESS: %d\t\t",ReadByte(ptrscrdrv+0x4a-0x18));
      printf("PT_BCURR: %d\n",ReadByte(ptrscrdrv+0x4b-0x18));
#endif
      x=getMouseX();
      y=getMouseY();
	

      /*if(xmouse)*/

      {
	/* printf("mouse pointer %sactivated\n",ptractive()?"":"de"); */
	if (!(ptractive())){
	  if (!lastactive)
	    {
	      pendreset=50;
	      lastactive=1;
	    }
	}
	else 
	  {
	    pendreset=0;
	    if (!invisible)
	      {
		if(!script)
		  {
		    invisible=1;
		    InvisibleMousePtr();
		  }
	      }
	    lastactive=0;
	  }
      }
      /*if (pendreset) printf("pendreset: %d\n",pendreset);*/
#if 1
      if (pendreset)
	if ( --pendreset<=0 )
	  {
	    if(!script)
	      {
		invisible=0;
		ResetMousePtr();
	      }
	    
	  }
#endif	  
      /* } */
      if (x!=lastx || y!=lasty)
	{
#if 0
	  printf("internal mouse change\n");
	  print_mousepos();
#endif
	  if (inside && !script){
#ifdef XAW
	    XWarpPointer(XtDisplay(bitMap), None,
			 XtWindow(bitMap), 0,0,0,0, x, y);
#else
	    XWarpPointer(display,None,imagewin,0,0,0,0, x,y);
	    lastx=x;
	    lasty=y;
#endif
	  }
	  
#if 0
	  printf("Mouse x,y = (%4d,%4d)\n",x,y);
#endif 
    }
}
  aReg[3]=saveA3;
}
#endif

#ifdef VM_SCR
#define DISPLAY_CHANGED() display_changed()
static inline int display_changed()
{
  int i=0;
  
  while (i<sct_size) 
    {
      if(scrModTable[i]) return 1;
      i++;
    }
  
  return 0;
}
#else
#define DISPLAY_CHANGED()  (displayTo-displayFrom>4 && displayFrom!=0)
#endif



#ifdef MOUSE
void QLMovePointer(int pos_x,int pos_y)
{
  if (HasPTR)
    if (pos_x!=lastx || pos_y!=lasty)
      {
	int cx,cy;
	
	cx=getMouseX();
	cy=getMouseY();
	
#if 0
	print_mousepos();
	printf("moveto: %d\t%d\n",pos_x,pos_y);
#endif
	setMouseXY(pos_x,pos_y);

	llastx=lastx; lastx=pos_x;
	llasty=lasty; lasty=pos_y;
      }
}
#endif


void SchedulerCmd()
{
  w32 saved_regs[16];
  
  if ((long)((Ptr)gPC-(Ptr)theROM)-2 != SCHEDULER_CMD_ADDR)
    {
      exception=4;
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
      return;
    }
  
  save_regs(saved_regs);

#ifndef XAW
  if (!script)
  process_events();
#endif
  if ((schedCount>min_idle || 
       (quickMouseUpdate && ptractive() && (llastx!=getMouseX() || llasty!=getMouseY()))) &&
      ((DISPLAY_CHANGED()) || 
	  (rx1<=rx2 && ry1<=ry2))  )
    {
#if 0
      if (quickMouseUpdate && ptractive() && (llastx!=getMouseX() || llasty!=getMouseY())) {printf(".");fflush(stdout);}
#endif

      scrcnt=5;
      finishflag=1;
      FlushDisplay();
#ifndef VM_SCR
      displayFrom=0; 
      displayTo=0; 
#endif
      finishflag=0;
      doscreenflush=0;


    }


#ifdef MOUSE
  MouseTask();
#endif

#ifndef VTIME
  if (schedCount++>min_idle)  /* QDOS running idle */
    {
      /*printf(".");fflush(stdout);*/

      if (nInst>5)
	{
	  nInst2=nInst;
	  nInst=1; 
	}
 
#ifndef __linux__
      pause();       
#else 
	{	    
	    sigset_t mask, oldmask;
	    /* Set up the mask of signals to temporarily block. */
	    sigemptyset (&mask);
	    sigaddset (&mask, SIGALRM);
	    /* Wait for a signal to arrive. */
	    sigprocmask (SIG_BLOCK, &mask, &oldmask);
	    while (schedCount)
		sigsuspend (&oldmask);
	    sigprocmask (SIG_UNBLOCK, &mask, NULL);
	}
#endif
    }
#endif /* VTIME */
  
  restore_regs(saved_regs);

  rts();
}


 
